#!/bin/bash
# Wrapper and cheaper on CPU for netapp-ontapsdk-perf.pl script
# Arguments: 
# $1: storage
# $2: user
# $3: pass
# $4: object
# $5: command (get, index, query, counter-list, object-list)
# $6: item queried
# $7: object on which

AGE=1 # minute
OUTFILE=/var/tmp/wrapper.$1.$4.$5
WRAPPED=/var/www/html/scripts/netapp-ontapsdk-perf.pl
# Do we have to call the script again?
find $OUTFILE -cmin +1 -exec rm {} \; > /dev/null 2>&1
if [ ! -f $OUTFILE ] 
then
	touch $OUTFILE.lock
	perl $WRAPPED $1 $2 $3 $4 $5 > $OUTFILE
	\rm $OUTFILE.lock > /dev/null 2>&1
fi

while [ -f $OUTFILE.lock ]
do
	sleep 0.1
done

# If the command ($5) is query
if [ "$5" == "query" ]
then
	# We forward the entire command, and do not intervene
	perl $WRAPPED $@
	exit 0
fi

# For Volume 
if [ -n "$6" ] 
then
	grep name:$7 $OUTFILE | tr ' ' '\n' | grep "^$6" | cut -f 2 -d :
else
	cat $OUTFILE
fi
